#include <Arduino.h>
#include <WiFi.h>
#include <PubSubClient.h>
#include <PubSubClientTools.h>
#include "ESPAsyncWebServer.h"
#include <AsyncMqttClient.h>

void setSound(uint16_t time);
void initGPIO();
void initSPI();
void connectWiFi();
void connectBroker();
void readBlock(byte block, byte *buffer);
void onMqttSubscribe(uint16_t packetId, uint8_t qos);
void onMqttDisconnect(AsyncMqttClientDisconnectReason reason);
void onMqttConnect(bool sessionPresent);
void onMqttSubscribe(uint16_t packetId, uint8_t qos);
void onMqttUnsubscribe(uint16_t packetId);
void onMqttPublish(uint16_t packetId);
void onMqttMessage(char *topic, char *payload, AsyncMqttClientMessageProperties properties, size_t len, size_t index, size_t total);
void messageLoop();
void responseAlive();
void mac_subscriber(String topic, String payload);
void publishLastCardInfo();
void readCardInfo();
void errorSound();
void writeBlocks(byte *buffer1, byte *buffer2, byte *buffer4, byte *buffer5,byte *buffer6);
void good();
void update();
void testAES();
void loadConfiguration();
void activate_AP();
void startServer();
void saveConfiguration();
void restart();
String processor(const String &var);
void soundLoop();
void blink();
void encrypt(char * plainText, const char * key, unsigned char * outputBuffer);
void decrypt(char * chipherText, const char * key, unsigned char * outputBuffer);
void readCardRawInfo();
void readCard();
void publishRawCardInfo();